#ifndef __CONTEXT__
#define __CONTEXT__ 

      
namespace XMLIOSERVER
{ 
   class Context : public ObjectTemplate<Context>
   {
      public:
            
         Context(void) : ObjectTemplate<Context>()
         {/* Ne rien faire de plus */}               
         Context(const string& _id) : ObjectTemplate<Context>(_id)
         {/* Ne rien faire de plus */}   
         
         void parse (XMLNode& _node)
         {
            THashAttributes attributes;
           
            /// PARSING POUR GESTION DES ENFANTS
            if (_node.getElementName().compare(string("context")))
               WARNING("Le noeud est mal nommé mais sera traité comme un context !");
            
            if (!(_node.goToChildElement()))
               WARNING("Le contexts ne contient pas d'enfant !"); 
            else
            {
               //////////////////////////////////////
              do { // Parcours des contexts pour traitement.        
                            
                  string name = _node.getElementName();
                  std::cout << name << std::endl;
                  attributes.clear();
                  _node.getAttributes(attributes);   
                  
                  if (attributes.end() != attributes.find("id"))
                  { WARNING("Le noeud de définition possède un identifiant, il ne sera pas pris en compte lors du traitement !"); }
                  
                  if (name.compare("field_definition") == 0)
                  { // Parsing pour la définition des champs.
                  
                     if (FieldDefinition::HasObject("field_definition")) 
                        WARNING("Le context possède déjà un noeud de définition de champs, le dernier défini complétera le premier !");
                     
                     fieldDef = (FieldDefinition*)&FieldDefinition::CreateObject("field_definition");
                     fieldDef->parse(_node, true);
                     continue;
                  }                  
                  // Traitement file, grid et axis à compléter.
               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent
            }
            
            return;
         }
         
         void registerAllAttributes(void)
         { /* Ne rien faire de plus */ }
         
         virtual const char* getName(void) const {return ("Context"); }
         
         FieldDefinition* getFieldDefinition(void) { return (this->fieldDef); }
                  
         ~Context()
         {/* Ne rien faire de plus pour le moment */ }
         
      protected:
      
      private:
      
         FieldDefinition*  fieldDef;
         /*FileDefinition* fileDef;
         AxisDefinition*   axisDef;
         GridDefinition*   gridDef;*/

      
   }; //class Context
}// namespace XMLIOSERVER

#endif  // __CONTEXT__
